import es
import os
import gamethread
import playerlib
from configobj import ConfigObj
import psyco
psyco.full()

info = es.AddonInfo()
info.name = 'Only HS au deagle'
info.author = 'SeriousKillerNaruto'
info.cssversion = 'OrangeBox'
info.basename = 'onlyhsdeagle'
info.version = '2.0'

config = 0

eventscripts_currentmap = str(es.ServerVar('eventscripts_currentmap'))
deathmatch = int(es.ServerVar('ohsd_deathmatch'))
respawn_delay = int(es.ServerVar('ohsd_respawn_delay'))
spawn_protection_time = int(es.ServerVar('ohsd_spawn_protection_time'))

bannedEntity = { 'bannedEntity1' : 'weapon_awp', 'bannedEntity2' : 'weapon_scout', 'bannedEntity3' : 'weapon_sg550', 'bannedEntity4' : 'weapon_g3sg1', 'bannedEntity5' : 'weapon_sg552', 'bannedEntity6' : 'weapon_aug', 'bannedEntity7' : 'weapon_ak47', 'bannedEntity8' : 'weapon_m4a1', 'bannedEntity9' : 'weapon_galil', 'bannedEntity10' : 'weapon_famas', 'bannedEntity11' : 'weapon_mp5navy', 'bannedEntity12' : 'weapon_ump45', 'bannedEntity13' : 'weapon_tmp', 'bannedEntity14' : 'weapon_p90', 'bannedEntity15' : 'weapon_mac10', 'bannedEntity16' : 'weapon_m3', 'bannedEntity17' : 'weapon_xm1014', 'bannedEntity18' : 'weapon_usp', 'bannedEntity19' : 'weapon_glock', 'bannedEntity20' : 'weapon_p228', 'bannedEntity21' : 'weapon_elite', 'bannedEntity22' : 'weapon_fiveseven', 'bannedEntity23' : 'weapon_hegrenade', 'bannedEntity24' : 'weapon_flashbang', 'bannedEntity25' : 'weapon_smokegrenade', 'bannedEntity26' : 'weapon_knife', 'bannedEntity27' : 'weapon_c4', 'bannedEntity28' : 'weapon_m249'}

def load():
	es.set('ohsd_deathmatch', 0)
	es.set('ohsd_respawn_delay', 0)
	es.set('ohsd_spawn_protection_time', 0)
	es.set('ohsd_version', info.version)
	es.makepublic('ohsd_version')

def respawn(userid):
	es.setplayerprop(userid, "CCSPlayer.m_iPlayerState", 0)
	es.setplayerprop(userid, "CCSPlayer.baseclass.m_lifeState", 512)
	es.server.insertcmd("es_xspawnplayer " + str(userid))

def SpawnProtectionON(userid):
	if playerlib.getPlayer(userid).team==2:
		playerlib.getPlayer(userid).setColor(255,0,0,255)
	if playerlib.getPlayer(userid).team==3:
		playerlib.getPlayer(userid).setColor(0,0,255,255)
	playerlib.getPlayer(userid).godmode = 1

def SpawnProtectionOFF(userid):
	playerlib.getPlayer(userid).setColor(255,255,255,255)
	playerlib.getPlayer(userid).godmode = 0

def cleanMap():
	entityList = es.createentitylist()
	for entityIndex in entityList:
		if entityList[entityIndex]['classname'].startswith('weapon_') or entityList[entityIndex]['classname'].startswith('item_') or entityList[entityIndex]['classname'].startswith('prop_') or entityList[entityIndex]['classname'] == 'cs_ragdoll':
			if int(es.getindexprop(entityIndex, 'CBaseEntity.m_hOwnerEntity')) == -1:
				es.server.insertcmd("es_xremove %s" % entityIndex)

def kill_function():
	es.remove('func_buyzone')
	if eventscripts_currentmap.split('_')[0]=='de':
		es.remove('func_bomb_target')
		es.remove('weapon_c4')
	if eventscripts_currentmap.split('_')[0]=='cs':
		es.remove('func_hostage_rescue')
		hostages = es.createentityindexlist('hostage_entity')
		for index in hostages:
			es.remove(index)
		es.remove('hostage_entity')

def RemoveRagdoll(handle):
	for ragdoll in es.createentitylist('cs_ragdoll'):
		if es.getindexprop(ragdoll, 'CBaseEntity.m_hOwnerEntity') == -1 or es.getindexprop(ragdoll, 'CBaseEntity.m_hOwnerEntity') == handle:
			es.server.insertcmd('es_xremove %i' % ragdoll)

def es_map_start(ev):
	global deathmatch,spawn_protection_time,spawn_protection_time, config
	if os.path.isfile(es.getAddonPath('onlyhsdeagle') + '/config.cfg'):
		config = ConfigObj(es.getAddonPath('onlyhsdeagle') + '/config.cfg')
		es.set('ohsd_deathmatch', int(config['ohsd_deathmatch']))
		es.set('ohsd_respawn_delay', int(config['ohsd_respawn_delay']))
		es.set('ohsd_spawn_protection_time', int(config['ohsd_spawn_protection_time']))
	else:
		config = open(es.getAddonPath('onlyhsdeagle') + '/config.cfg', 'w')
		config.write('# set to 1 to enable deathmatch')
		config.write('\n')
		config.write('ohsd_deathmatch = 0')
		config.write('\n')
		config.write('\n')
		config.write('# set respawn delay (Only work if deathmatch is ON)')
		config.write('\n')
		config.write('ohsd_respawn_delay = 0')
		config.write('\n')
		config.write('\n')
		config.write('# set spawn protection time (Only work if deathmatch is ON)')
		config.write('\n')
		config.write('ohsd_spawn_protection_time = 0')
		config.write('\n')

def round_start(ev):
	global deathmatch
	cleanMap()
	if deathmatch == 1:
		kill_function()
	for clef, val in bannedEntity.items():
		es.delayed('.1', 'es_xremove %s' % val)
		es.server.insertcmd('use weapon_deagle')

def player_spawn(ev):
	userid = ev['userid']
	if spawn_protection_time > 0 and deathmatch == 1:
		SpawnProtectionON(userid)
		es.tell(userid, '#green', 'You are spawn protected for %.1f seconds' % spawn_protection_time)
		gamethread.delayed(spawn_protection_time, SpawnProtectionOFF, userid)
	es.delayed('.2', 'es_give %s weapon_deagle' % userid)
	es.delayed('.3', 'es playerset ammo %s 2 999' % userid)
	es.server.insertcmd('es playerset health %s 5000' % userid)
	es.setplayerprop(userid, 'CCSPlayer.m_ArmorValue', 0)
	es.setplayerprop(userid, 'CCSPlayer.m_bHasHelmet', 0)

def item_pickup(ev):
	for clef, val in bannedEntity.items():
		es.server.insertcmd('es_remove %s' % val)
		es.server.insertcmd('use weapon_deagle')

def player_hurt(ev):
	userid = ev['userid']
	attacker = ev['attacker']
	weapon = ev['weapon']
	hitgroup = ev['hitgroup']
	if weapon != 'world':
		if hitgroup == '1':
			if es.isbot(attacker) == 1:
				es.server.insertcmd('score add %s 1' % attacker)
				es.server.insertcmd('score add %s 1' % userid)
				es.server.insertcmd('damage %s 10000 1073741824 %s weapon_deagle' % (userid,userid))
			else:
				es.server.insertcmd('damage %s 10000 1073741824 %s weapon_deagle' % (userid,attacker))
		else:
			es.server.insertcmd('es playerset health %s 5000' % userid)
			es.setplayerprop(userid, 'CCSPlayer.m_ArmorValue', 0)
			es.setplayerprop(userid, 'CCSPlayer.m_bHasHelmet', 0)

def player_death(ev):
	global deathmatch,spawn_protection_time,spawn_protection_time
	userid = int(ev['userid'])
	handle = es.getplayerhandle(userid)
	if deathmatch == 1:
		gamethread.delayed(.1, RemoveRagdoll, handle)
		if respawn_delay > 0:
			es.tell(userid, '#green', 'You will respawn in %.1f seconds' % respawn_delay)
			gamethread.delayed(respawn_delay, respawn, userid)
		else:
			respawn(userid)

def player_say(ev):
	global deathmatch,spawn_protection_time,spawn_protection_time
	if ev['text'] == '.settings':
		es.tell(ev['userid'], 'deathmatch : %s' % deathmatch)
		es.tell(ev['userid'], 'respawn_delay : %s' % respawn_delay)
		es.tell(ev['userid'], 'spawn_protection_time : %s' % spawn_protection_time)

def player_falldamage(ev):
	userid = ev['userid']
	es.server.insertcmd('es playerset health %s 5000' % userid)

def weapon_reload(ev):
	userid = ev['userid']
	es.server.insertcmd('es playerset ammo %s 2 999' % userid)

def weapon_fire_on_empty(ev):
	userid = ev['userid']
	es.server.insertcmd('es playerset ammo %s 2 999' % userid)